from osv import osv,fields
import time
from datetime import datetime, timedelta
import urllib
import urllib2
import xml.etree.ElementTree
import re
import tools # for emailing
from operator import itemgetter

# osv.memory makes it temporary
class wiz_import_status(osv.osv_memory):
    _name="wiz.import.status"
    _columns={
        "url": fields.char("URL",size=128,required=True),
        "realm": fields.char("Realm", size=128, required=True),
            "login": fields.char("Login",size=64, required=True),
            "password": fields.char("Password",size=64, required=True),
            "num_msgs": fields.integer("Number of Messages To Import"),
            "journal_id": fields.many2one("account.analytic.journal","Analytic Journal", required=True),
            "general_account_id": fields.many2one("account.account","General Account", required=True),
            "default_analytic_account_id": fields.many2one("account.analytic.account", "Default Analytic Account", required=True),
        }

    def manage_import(self, cr, uid, ids, context={}):
        print "---- Twitter Import ----"
        # If running from the scheduler, use default values
        if "args" in ids:
            num_msgs = 100
        else:
            wiz = self.browse(cr, uid, ids[0])
            num_msgs = wiz.num_msgs
        
        num_checked = 0
        min_id = self.do_import(cr, uid, ids)
        num_checked += 20
        while (num_checked < num_msgs):
            min_id = self.do_import(cr, uid, ids, max_id = min_id - 1)
            num_checked += 20
        print "Checked ", num_checked, " Messages" 
        return {}

    def do_import(self,cr,uid,ids,context={}, max_id = None):
        # If running from scheduler
        if "args" in ids:
            arg_url = ids["args"]["url"]
            arg_realm = ids["args"]["realm"]
            arg_login = ids["args"]["login"]
            arg_password = ids["args"]["password"]
            arg_journal_id = self.pool.get("account.analytic.journal").search(cr, uid, [("code", "=", ids["args"]["journal_code"])])[0]
            arg_general_account_id = self.pool.get("account.account").search(cr, uid, [("name", "=", ids["args"]["general_account"])])[0]
            arg_default_analytic_account_id = self.pool.get("account.analytic.account").search(cr, uid, [("name", "=", ids["args"]["default_account"])])[0]
        else:
            # the ids[0] is the wiz object, filled in from the view
            wiz = self.browse(cr,uid,ids[0])
            arg_url = wiz.url
            arg_realm = wiz.realm
            arg_login = wiz.login
            arg_password = wiz.password
            arg_journal_id = wiz.journal_id.id
            arg_general_account_id = wiz.general_account_id.id
            arg_default_analytic_account_id = wiz.default_analytic_account_id.id

        auth_handler = urllib2.HTTPBasicAuthHandler()
        url= arg_url + "api/statuses/public_timeline.xml" + (max_id and "&max_id=%d" % max_id or "")
        auth_handler.add_password(realm = arg_realm, uri=url, user=arg_login, passwd=arg_password)
        opener = urllib2.build_opener(auth_handler)
        urllib2.install_opener(opener)
        data = urllib2.urlopen(url, timeout=30).read()
        doc = xml.etree.ElementTree.fromstring(data)
        # messages need to be of the format: !wp wk31 5.5h desc of tasks or !wp mon 5.5h desc of tasks
        # ! is optional, wp is the project code
        # can be used to record expenses too, so 5.5h can be 5.5b to indicate 5.5 Baht spent
        # the wk31 is optional, it can come before or after the 5.5h element - used to modify previous week entries
        # the mon is optioal, can come before or after 5.5h element (cannot have both week and day name though) - used to modify specific day entries
        # the hours number can be negative as well
        # messages can be posted on behalf of another user by going like "!wp user pvishayanuroj 8h lalala"
        #expr = re.compile('^!?(\w+) work (\d+)h (.*)', re.IGNORECASE)
        #expr = re.compile('^!?(\w+) +(wk\d+ +)?(-?\d+(\.\d+)?(h|b)) +(wk\d+ +)?(.*)', re.IGNORECASE)
        #expr = re.compile('^!?(\w+) +((wk\d+ +)|((mon|tues|wed|thurs|fri) +))?(-?\d+(\.\d+)?(h|b)) +((wk\d+ +)|((mon|tues|wed|thurs|fri) +))?(.*)', re.IGNORECASE)
        #expr = re.compile('^!?(\w+) +(user +\w+ +)?((wk\d+ +)|((mon|tues|wed|thurs|fri) +))?(-?\d+(\.\d+)?(h|b)) +((wk\d+ +)|((mon|tues|wed|thurs|fri) +))?(.*)', re.IGNORECASE)
        expr = re.compile('^!?(\w+) +(user +(\w+) +)?((wk(\d+) +)|((mon|tue|tues|wed|thu|thur|thurs|fri) +))?(-?\d+(\.\d+)?)(h|b) +(.*)', re.IGNORECASE)
        # Groups: 0 = all, 1 = project, 3 = user, 6 = weeknum, 8 = weekday, 9 = amount, 11 = hours or baht, 12 = message 
        day_dict = {"mon": 1, "tues": 2, "tue": 2, "wed": 3, "thu": 4, "thur": 4, "thurs": 4, "fri": 5}

        print "---- Successful Import. Iterating through messages ---- "
        # keep a count
        count = 0
        min_id = 0
        for node in doc.getiterator("status"):
            # Check if this message matches a worklog entry
            text = node.find("text").text
            match = expr.search(text)
            # Get each message's ID, even if it not related
            ref = node.find("id").text
            min_id = int(ref)
            if match:
                # Check if this entry is already in the DB
                res = self.pool.get("account.analytic.line").search(cr, uid, [("ref", "=", ref)])
                if not res:
                    # Get some other info from the tweet
                    date = node.find("created_at").text
                    user = node.find("user/screen_name").text
                    # Format the date correctly
                    ftime = time.strptime(date, "%a %b %d %H:%M:%S +0000 %Y")
                    fdate = time.strftime("%Y-%m-%d", ftime)
                    year = time.strftime("%Y", ftime)
                    curr_week = time.strftime("%W", ftime)
                    # Parsing
                    code = match.group(1)
                    desc = match.group(12)
                    # Figure out if hours or baht, default is hours
                    if match.group(11) == "b":
                        hours = 0
                        amount = float(match.group(9))
                    else:
                        hours = float(match.group(9))
                        amount = 0
                    # If the week argument is included, calculate a new date for this message
                    if match.group(6):
                        wk = match.group(6)
                        # Set it to the Friday of that week
                        newdate = "5 " + wk + " " + year
                        ftime = time.strptime(newdate, "%w %W %Y")
                        fdate = time.strftime("%Y-%m-%d", ftime)
                    # If the day argument is included, calculate the correct date
                    if match.group(8):
                        day = match.group(8)
                        newdate = "%d " % day_dict[day] + curr_week + " " + year
                        ftime = time.strptime(newdate, "%w %W %Y")
                        fdate = time.strftime("%Y-%m-%d", ftime)
                    # If this post is being made on behalf of another user
                    if match.group(3):
                        user = match.group(3)
                    
                    # Debug
                    """
                    print "msg: " + desc
                    print "ref: " + ref
                    print "date: " + fdate
                    print "user: " + user
                    print "code: " + code
                    print "amount: " + amount
                    print "hours: ", hours
                    """
                    # Search for the analytic account associated with this entry
                    res=self.pool.get("account.analytic.account").search(cr, uid, [("code","=",code)])
                    if not res:
                        print "Warning - Account code " + code + " does not exist - Placing in default analytic account"
                        account_id = arg_default_analytic_account_id
                    else:
                        account_id=res[0]
                    user_res = self.pool.get("res.users").search(cr, uid, [("statusnet_login", "=", user)])
                    if not user_res:
                        print "Warning - StatusNet login " + user + " does not exist in DB - Skipping message"
                        continue
                    user_id=user_res[0]
                    vals={
                        "name": desc,
                        "date": fdate,
                        "account_id": account_id,
                        "amount": amount,
                        "unit_amount": hours,
                        "journal_id": arg_journal_id, 
                        "general_account_id": arg_general_account_id,
                        "ref": ref,
                        "user_id": user_id,
                    }
                    line_id=self.pool.get("account.analytic.line").create(cr,uid,vals)
                    count += 1
                #endif
            #endif
        #endfor
        print "Logged %d messages" % count
        return min_id
wiz_import_status()

class wiz_calculate_totals(osv.osv_memory):
    _name = "wiz.calculate.totals"
    _columns = {
        "url": fields.char("URL",size=128,required = True),
        "realm": fields.char("Realm", size = 128, required = True),
        "login": fields.char("Login",size=64, required = True),
        "password": fields.char("Password",size=64, required = True),
    }

    def calculate_totals(self, cr, uid, ids, context={}):
        print "---- Calculating Work Totals ---- "

        # Determine date from to be from the last Monday this week
        curr_time = datetime.now()
        dayofweek = curr_time.weekday()
        delta = timedelta(days = dayofweek)
        start_time = curr_time - delta
        start_time = start_time.replace(hour = 0, minute = 0, second = 0, microsecond = 0)
        date_from = start_time.strftime("%Y-%m-%d")
        weeknum = start_time.strftime("%W")
        date_to = curr_time.strftime("%Y-%m-%d")

        user_msg = "Hours per User (Week " + weeknum + ") -- "
        project_msg = "Hours per Project (Week " + weeknum + ") -- "
        print "date_from: " + date_from
        print "date_to: " + date_to

        # Per Person
        user_hours={}
        # Go through all users
        user_ids = self.pool.get("res.users").search(cr, uid, []) # empty array to get all users
        for user in self.pool.get("res.users").browse(cr, uid, user_ids):
            # Query to find all analytic lines with this particular user id
            # Don't use date_to, since it ignores the current day entries sometimes
            line_ids = self.pool.get("account.analytic.line").search(cr, uid, [("user_id", "=", user.id), ("date", ">", date_from)])
            hours = 0
            # Go through all this user's analytic entries
            for line in self.pool.get("account.analytic.line").browse(cr, uid, line_ids):
                        hours += line.unit_amount
            # Store in dictionary as long as user has a statusnet login
            if user.statusnet_login:
                user_hours[user.statusnet_login] = hours
        # end outer for
        # Sort the users by name and generate text
        sorted_users = sorted(user_hours.items())
        for index, u in enumerate(sorted_users):
            if index == 0:
                user_msg = user_msg + "%s: %g" % (u[0], u[1])
            else:
                user_msg = user_msg + ", %s: %g" % (u[0], u[1])

        # Per Project
        project_hours={}
        # Go through all projects
        project_ids = self.pool.get("account.analytic.account").search(cr, uid, [])
        for project in self.pool.get("account.analytic.account").browse(cr, uid, project_ids):
            # Query to find all analytic lines with this particular account id
            # Don't use date_to, since it ignores the current day entries sometimes
            line_ids = self.pool.get("account.analytic.line").search(cr, uid, [("account_id", "=", project.id), ("date", ">", date_from)])
            hours = 0
            # Go through all of this project's analytic entries
            for line in self.pool.get("account.analytic.line").browse(cr, uid, line_ids):
                hours += line.unit_amount
            # Store in dictionary only if project has been worked on this week
            if hours > 0:
                project_hours[project.code] = hours
        #end outer for

        # Sort the projects by hours and generate the text
        sorted_projects = sorted(project_hours.items(), key=lambda x: -x[1])
        for index, p in enumerate(sorted_projects):
            if index == 0:
                project_msg = project_msg + "%s: %g" % (p[0], p[1])
            else:
                project_msg = project_msg + ", %s: %g" % (p[0], p[1])

        print "Msg 1: " + user_msg
        print "Msg 2: " + project_msg
        return {"user_msg" : user_msg, "project_msg" : project_msg}

    def post_totals(self, cr, uid, ids, context={}):

        msgs = self.calculate_totals(cr, uid, ids)

        wiz = self.browse(cr, uid, ids[0])
        arg_url = wiz.url
        arg_realm = wiz.realm
        arg_login = wiz.login
        arg_password = wiz.password

        print "---- Posting to Twitter ---- "
        # Post the message on Twitter
        user_msg_data = urllib.urlencode({"status" : msgs["user_msg"]})
        proj_msg_data = urllib.urlencode({"status" : msgs["project_msg"]})
        auth_handler = urllib2.HTTPBasicAuthHandler()
        url = arg_url + "api/statuses/update.xml"
        print "URL: " + url
        auth_handler.add_password(realm=arg_realm, uri = url, user = arg_login, passwd = arg_password)
        opener = urllib2.build_opener(auth_handler)
        urllib2.install_opener(opener)
        urllib2.urlopen(url, user_msg_data, 30);
        urllib2.urlopen(url, proj_msg_data, 30);

        return {}
wiz_calculate_totals()

class wiz_reminder(osv.osv_memory):
    _name = "wiz.reminder"
    _columns = {
        "url": fields.char("URL",size=128,required = True),
        "realm": fields.char("Realm", size = 128, required = True),
        "login": fields.char("Login",size=64, required = True),
        "password": fields.char("Password",size=64, required = True),
        "admin_email_address": fields.char("Administrator Email Address", size = 128, required = True),
        "email_users_check": fields.boolean("Send Email to Users?"),
        "email_admin_check": fields.boolean("Send Email to Admin?"),
        "twitter_check": fields.boolean("Post Reminder to Twitter?"), 
        "project_totals_check": fields.boolean("Post Project Totals on Twitter?"),
        "date": fields.date("Date",required=True),
    }
    _defaults={
        "date": lambda *a: time.strftime("%Y-%m-%d"),
    }

    # The mode argument can be either "Daily" or "Weekly"
    def reminder(self, cr, uid, ids, context = {}, mode = "Daily", date = None):
        if mode == "Daily":
            daily = 1
        elif mode == "Weekly":
            daily = 0
        else:
            raise osv.except_osv("Error", "Invalid mode for reminder method. Mode can be either Weekly or Daily")

        # Need non-zero hours if daily, 40 hours if weekly
        hours_needed = daily and 1 or 40

        # Determine date "from" to be yesterday if daily, last Sunday if weekly
        if date:
            curr_time=datetime.strptime(date,"%Y-%m-%d")
        else:
            curr_time = datetime.now()
        dayofweek = curr_time.weekday() # (Monday = 0 why this is different than in the time module, I have no idea...)
        # If daily reminder and it's Saturday or Sunday, don't do anything
        if daily == 1 and dayofweek > 4:
            print "Abort sending daily reminder - It's the weekend!"
            return {}

        # If daily reminder, use yesterday's date as the "from". If weekly, use last Sunday 
        delta = daily and timedelta(days = 1) or timedelta(days = dayofweek + 1)
        start_time = curr_time - delta
        start_time = start_time.replace(hour = 0, minute = 0, second = 0, microsecond = 0)
        date_from = start_time.strftime("%Y-%m-%d") # What to pass to the query
        date_to = curr_time.strftime("%Y-%m-%d")
        # The string that shows up in emails and twitter updates 
        date_string = daily and curr_time.strftime("%A, %B %d, %Y") or start_time.strftime("%B %d, %Y (Week %W)")

        print "date_from: " + date_from
        user_hours = {}

        # Go through all users
        user_ids = self.pool.get("res.users").search(cr, uid, []) # empty array to get all users
        for user in self.pool.get("res.users").browse(cr, uid, user_ids):
            # Don't bother if user is not associated with statusnet
            if not user.statusnet_login:
                continue
            
            # Query to find all analytic lines with this particular user id
            # Don't use date_to, since it ignores the current day entries sometimes
            line_ids = self.pool.get("account.analytic.line").search(cr, uid, [("user_id", "=", user.id), ("date", ">", date_from), ("date", "<=", date_to)])
            hours = 0
            summary = []
            # Go through all this user's analytic entries
            for line in self.pool.get("account.analytic.line").browse(cr, uid, line_ids):
                account = self.pool.get("account.analytic.account").browse(cr, uid, line.account_id.id)
                hours += line.unit_amount
                # Only record this if hours is greater than zero - we can have an expenses entry with zero hours    
                if line.unit_amount > 0:
                    summary.append((line.unit_amount, account.code, line.date))
            # Check for a valid address
            if not user.address_id:
                print "User " + user.statusnet_login + " does not have an address object associated - Skipping user"
                continue

            # Get their email address
            addr = self.pool.get("res.partner.address").browse(cr, uid, user.address_id.id)
            if not addr.email:
                print "User " + user.statusnet_login + " does not an email address - Skipping user"
                continue
            
            # For users that logged less than the required amount
            if hours < hours_needed:
                user_hours[user.statusnet_login] = {"total_hours": hours, "email_address": addr.email, "breakdown": summary}
            # end for all users

        # Per Project
        project_hours={}
        # Go through all projects
        project_ids = self.pool.get("account.analytic.account").search(cr, uid, [])
        for project in self.pool.get("account.analytic.account").browse(cr, uid, project_ids):
            # Query to find all analytic lines with this particular account id
            # Don't use date_to, since it ignores the current day entries sometimes
            line_ids = self.pool.get("account.analytic.line").search(cr, uid, [("account_id", "=", project.id), ("date", ">", date_from)])
            hours = 0
            # Go through all of this project's analytic entries
            for line in self.pool.get("account.analytic.line").browse(cr, uid, line_ids):
                hours += line.unit_amount
            # Store in dictionary only if project has been worked on
            if hours > 0:
                # Record hours worked on project during this interval along with total hours spent on the project
                project_hours[project.code] = (hours, project.quantity)
            #end for all projects

        return {"user_hours": user_hours, "project_hours": project_hours, "date": date_string}
   
    def email_reminders(self, cr, uid, ids, data, context = {}, mode = "Daily", email_users = 1, email_admin = 1):
        
        # Default arguments if running from the scheduler
        if "args" in ids:
            arg_admin_email = ids["args"]["admin_email"]
        else:
            wiz = self.browse(cr, uid, ids[0])
            arg_admin_email = wiz.admin_email_address
        
        if mode == "Daily":
            daily = 1
        elif mode == "Weekly":
            daily = 0
        else:
            raise osv.except_osv("Error", "Invalid mode for reminder method. Mode can be either Weekly or Daily")

        # Need non-zero hours if daily, 40 hours if weekly
        hours_needed = daily and 1 or 40
      
        # Generate the email subject and part of the body
        email_subject = daily and "[AUTOTIME WARNING] Daily Reminder" or "[AUTOTIME WARNING] Weekly Reminder"
        opening = daily and "Your total logged hours for " + data["date"] or "Your total logged hours for the week of " + data["date"]
        opening += " is below %d hour. Please update your totals. \n\nYour hours:\n" % hours_needed
        admin_email_subj = daily and "[AUTOTIME SUMMARY] Daily Summary" or "[AUTOTIME SUMMARY] Weekly Summary"
        admin_email_body = "Reminders sent: \n"

        # Sort the users by name and generate text
        sorted_users = sorted(data["user_hours"].items())
        for index, user in enumerate(sorted_users):
            email_body = "NOTICE for user " + user[0] + ":\n\n"
            email_body += opening
            for entry in user[1]["breakdown"]: 
                email_line = daily and "\n%4.1f " % entry[0] + entry[1] or "\n%4.1f " % entry[0] + entry[1] + " -- " + entry[2]
                email_body += email_line
            email_body += "\n---------\n%4.1f hours" % user[1]["total_hours"]
            email_body += "\n\nThis is an automated email. Do not reply to this email"
            
            admin_email_body += "\n" + user[0] + " %d hours" % user[1]["total_hours"]

            # Email it if checked
            if email_users:
                print "Emailed: " + user[1]["email_address"] 
                tools.email_send("donotreply@almacom.co.th", [user[1]["email_address"]], email_subject, email_body)

        # If the option to send a summary to the admin was ticked
        if email_admin:
            print "Emailed admin: " + arg_admin_email
            tools.email_send("donotreply@almacom.co.th", [arg_admin_email], admin_email_subj, admin_email_body)

        return {}

    def twitter_reminder(self, cr, uid, ids, data, mode = "Daily", context = {}):
        
        if mode == "Daily":
            daily = 1
        elif mode == "Weekly":
            daily = 0
        else:
            raise osv.except_osv("Error", "Invalid mode for reminder method. Mode can be either Weekly or Daily")

        twitter_msg = "Users with < %d hour(s) " % (daily and 1 or 40) + (daily and "on " or "for the week of ") + data["date"] + " -"

        # Sort users by name
        sorted_users = sorted(data["user_hours"].items())
        for user in sorted_users: 
            twitter_msg += " " + user[0] + ": %gh," % user[1]["total_hours"]
        
        # Get rid of the last comma
        twitter_msg = twitter_msg.strip(",")
       
        self.twitter_post(cr, uid, ids, twitter_msg)

        return {}

    def twitter_project_totals(self, cr, uid, ids, data, mode = "Daily", context = {}):

        if mode == "Daily":
            daily = 1
        elif mode == "Weekly":
            daily = 0
        else:
            raise osv.except_osv("Error", "Invalid mode for reminder method. Mode can be either Weekly or Daily")
        
        twitter_msg = "Project totals " + (daily and "on " or "for the week of ") + data["date"] + " -"
        
        # Sort the projects by hours and generate the text
        sorted_projects = sorted(data["project_hours"].items(), key=lambda x: -x[1][0])        
        for p in sorted_projects:
            twitter_msg += " %s: %g/%gh," % (p[0], p[1][0], p[1][1])
        
        # Get rid of the last comma
        twitter_msg = twitter_msg.strip(",")

        self.twitter_post(cr, uid, ids, twitter_msg)

        return {}

    def daily_reminder(self, cr, uid, ids, context = {}):
        # If running from the scheduler 
        if "args" in ids:
            arg_email_users_check = 1
            arg_email_admin_check = 1
            arg_twitter_check = 1
            arg_project_totals_check = 1
            data = self.reminder(cr, uid, ids, mode = "Daily")
        else:
            wiz = self.browse(cr, uid, ids[0])
            arg_email_users_check = wiz.email_users_check
            arg_email_admin_check = wiz.email_admin_check
            arg_twitter_check = wiz.twitter_check
            arg_project_totals_check = wiz.project_totals_check
            data = self.reminder(cr, uid, ids, mode = "Daily", date = wiz.date)

        # If there is nothing to send (i.e. it's the weekend)
        if not data:
            return {}

        print "---- Sending daily reminders ----"
        # Call email reminders with the arguments from the wizard - whether or not to send an email to users and to admin
        self.email_reminders(cr, uid, ids, data, mode = "Daily", email_users = arg_email_users_check, email_admin = arg_email_admin_check)
        # Only do a twitter update if checked
        if arg_twitter_check:
            self.twitter_reminder(cr, uid, ids, data, mode = "Daily")
        if arg_project_totals_check: 
            self.twitter_project_totals(cr, uid, ids, data, mode = "Daily")
        print "---- Done sending daily reminders ----"

        return {}

    def weekly_reminder(self, cr, uid, ids, context = {}):
        # If running from the scheduler 
        if "args" in ids:
            arg_email_users_check = 1
            arg_email_admin_check = 1
            arg_twitter_check = 1
            arg_project_totals_check = 1
        else:
            wiz = self.browse(cr, uid, ids[0])
            arg_email_users_check = wiz.email_users_check
            arg_email_admin_check = wiz.email_admin_check
            arg_twitter_check = wiz.twitter_check
            arg_project_totals_check = wiz.project_totals_check

        print "---- Sending weekly reminders ----"
        data = self.reminder(cr, uid, ids, mode = "Weekly")
        # Call email reminders with the arguments from the wizard - whether or not to send an email to users and to admin
        self.email_reminders(cr, uid, ids, data, mode = "Weekly", email_users = arg_email_users_check, email_admin = arg_email_admin_check)
        # Only do a twitter update if checked
        if arg_twitter_check:
            self.twitter_reminder(cr, uid, ids, data, mode = "Weekly")
        if arg_project_totals_check: 
            self.twitter_project_totals(cr, uid, ids, data, mode = "Weekly")
        print "---- Done sending weekly reminders ----"
        return {}
    
    def twitter_post(self, cr, uid, ids, message, context = {}):
        
        # Default arguments if running from the scheduler
        if "args" in ids:
            arg_url = ids["args"]["url"]
            arg_realm = ids["args"]["realm"]
            arg_login = ids["args"]["login"]
            arg_password = ids["args"]["password"]
        else:
            wiz = self.browse(cr, uid, ids[0])
            arg_url = wiz.url
            arg_realm = wiz.realm
            arg_login = wiz.login
            arg_password = wiz.password

        print "---- Posting to Twitter ---- "
        # Post the message on Twitter
        msg = urllib.urlencode({"status" : message})
        auth_handler = urllib2.HTTPBasicAuthHandler()
        url = arg_url + "api/statuses/update.xml"
        print "URL: " + url
        print "Message: " + message
        auth_handler.add_password(realm=arg_realm, uri = url, user = arg_login, passwd = arg_password)
        opener = urllib2.build_opener(auth_handler)
        urllib2.install_opener(opener)
        urllib2.urlopen(url, msg, 30); # timeout of 30s

        print "---- Finished posting to Twitter ----"
        return {}

wiz_reminder()

class res_users(osv.osv):
    _inherit = "res.users"
    _columns = {
        "statusnet_login": fields.char("StatusNet Login",size=64),
    }
res_users()

class report_work_hours(osv.osv):
    _name="report.work.hours"
    _auto=False
    _columns={
        "week": fields.char("Week",size=64,select=1),
        "project_id": fields.many2one("account.analytic.account","Project",select=1),
        "user_id": fields.many2one("res.users","User",select=1),
        "hours": fields.float("Hours"),
    }
    def init(self,cr):
        cr.execute("""
            create or replace view report_work_hours as (
                select
                    min(l.id) as id,
                    to_char(l.date,'YYYY-IW') as week,
                    l.account_id as project_id,
                    l.user_id as user_id,
                    sum(l.unit_amount) as hours
                from account_analytic_line l
                group by to_char(l.date,'YYYY-IW'),l.account_id,l.user_id
            )
        """)
report_work_hours()
